		;CDex 1.70
;scripts version 2.0 pour Jaws 7.10
;Jean-Claude.Armingaud@wanadoo.fr

include "hjconst.jsh"
include "CDex.jsm"

Globals
int CDexFirstTime,
string sCurrentView

const
sfn1 = 1,
sfn2 = 2,
sfn3 = 3


String Function parsetime (string sTime)
var
	string thestring,
	string seg1,
	string seg2
	let seg1 = StringSegment (sTime, ":", 1)
if (seg1 != 0) then
	let seg1 = FormatString ("%1 minute", seg1)
else
	let seg1 = ""
endif	
	let thestring = stringSegment (sTime, ":", 2)
	let seg2 = thestring
if (seg2 != 00) then
	if (StringLeft (seg2, 1)) != 0 then
		let seg2 = FormatString (" %1 ", seg2)
	else
		let seg2 = FormatString (" %1 ", StringRight (Seg2, 1))
	endif
else
	let seg2 = ""
endif
	let sTime = seg1 + seg2
if sTime == "" + "" then
	return
else
	return sTime
endif
EndFunction

void Function ClickButton (int iButton)
var handle hwnd
SpeechOff ()
if QuelleFenetre () != sfn2 then
	TypeKey ("Alt+t")
	pause ()
	TypeKey ("e")
	delay (5)
endif
let hwnd = FindDescendantWindow (GetTopLevelWindow (GetCurrentWindow ()), iButton)
if !hwnd then
	SpeechOn ()
	saystring ("fentre non trouve")
else
	MoveToWindow (hwnd)
endif
LeftMouseButton ()
pause ()
SpeechOn ()
EndFunction

Function ComparColor ()
var int C1, int C2, string s1
let C1 = GetColorBackground ()
let s1 = GetWord ()
NextWord ()
let c2 = GetColorBackground ()
if C1 != C2 && s1 == "pause" then
	saystring ("en pause")
elif C1 == C2 && s1 == "pause" then
	saystring ("")
else
	saystring ("stop")
endif
EndFunction

Script RecordButton ()
;Ctrl+shift+e
ClickButton (cid_enreg)
EndScript

Script PauseButton ()
;Ctrl+shift+z
ClickButton (cid_pause)
pause ()
ComparColor ()
EndScript

Script stopbutton ()
;Ctrl+shift+s
ClickButton (cid_stop)
pause ()
ComparColor ()
EndScript

Script ExitButton ()
;Ctrl+shift+q
ClickButton (cid_annuler)
PCCursor ()
EndScript

Script ScriptFileName ()
If IsSameScript () then
	SayMessage (Ot_Help, msgScriptFileName)
Else
	ScriptAndAppNames ("CDex")
Endif
EndScript

Function AutoStartEvent ()
var int i
if CDexFirstTime == 0 then
	let CDexFirstTime = 1
	SayFormattedMessage (OT_no_Disable, msgHelp)
endif
;delay (10)
While (GetControlID (GetFocus ()) != 1009) && i <= 8
DELAY (2)
TypeKey ("shift+tab")
let i = i + 1
endWhile
EndFunction

Function AutoFinishEvent ()
PCCursor ()
EndFunction

Script HotKeyHelp ()
If UserBufferIsActive () then
	UserBufferDeactivate ()
EndIf
if IsSameScript () == 2 then
	;pour lire l'aide relative  la fentre "lecteur fichiers"
	Delay (2)
	SayFormattedMessage (OT_USER_BUFFER, msgHotKey2)
elif IsSameScript () == 1 then
	;pour lire l'aide relative  la fentre "enregistrement"
	Delay (4)
	SayFormattedMessage (OT_USER_BUFFER, msgHotKey1)
else
	;pour lire l'aide relative  la fentre principale
	delay (5)
	SayFormattedMessage (OT_USER_BUFFER, msgHotKey)
endif
EndScript

Script ScreenSensitiveHelp ()
   ;avec Insert+F1
var string HtmFile, string sQuote
let sQuote = "\34"
let HtmFile = GetJAWSSettingsDirectory () + "\\CDex.htm"
if GetJFWVersion () >= 600 then
	let HtmFile = sQuote + HtmFile + squote
else
	let HtmFile = GetJawsSettingsDirectory ()+"\\CDex.htm"
endif
pause ()
run (HtmFile)
EndScript

Script saywindowtitle ()
var handle hwnd
if IsSameScript () then
	PerformScript SayWindowTitle()
else
	if QuelleFenetre () == sfn3 then
		MoveToControl (GetParent (GetCurrentWindow ()), 1043)
		SayWindow (GetCurrentWindow (), Read_everything)
	elif QuelleFenetre () == sfn1 then
		SaveCursor ()
		JAWSCursor ()
		RouteJAWSToPc ()
		SayChunk ()
	else
		MoveToControl (GetParent (GetCurrentWindow ()), 1119)
		SayWindow (GetCurrentWindow (), Read_everything)
	endif
	PCCursor ()
endif
EndScript

Script Ouvrir ()
		;Ctrl+o
var handle hwnd
SpeechOff ()
if QuelleFenetre () != "Lecteur CDex" then
	ActivateMenuBar ()
	pause ()
	NextCharacter () NextCharacter () NextCharacter ()
	pause ()
	NextLine ()
	EnterKey ()
	delay (5)
endif
let hwnd = FindDescendantWindow (GetTopLevelWindow (GetCurrentWindow ()), 59392)
if !hwnd then
	SpeechOn ()
	Delay (5)
	saystring ("fentre non trouve")
else
	MoveToWindow (hwnd)
endif
LeftMouseButton ()
pause ()
SpeechOn ()
PCCursor ()
EndScript

void Function PressButton (int ib)
		;pour le lecteur fichiers
var handle hwnd, int il
JAWSCursor ()
RouteJAWSToPc ()
Pause ()
let hwnd = GetParent (GetCurrentWindow ())
let hwnd = GetNextWindow (GetNextWindow (hwnd))
let hwnd = GetFirstChild (hwnd)
MoveToWindow (hwnd)
if GetWindowClass (GetCurrentWindow ()) != "ToolbarWindow32" then 
	saystring ("fentre non trouve")
else
	let il = 1
	while il < ib					
	let il = il + 1
	NextWord ()
	endwhile
	LeftMouseButton ()
	PCCursor ()
endif
EndFunction

void Function WinCD (int i)
var handle hwnd, int il
let hwnd = GetAppMainWindow (GetCurrentWindow ())
let hwnd = FindDescendantWindow (hwnd, 59402)
MoveToWindow (hwnd)
if !hwnd then
	saystring ("fentre non trouve")
endif
NextWord ()
RefreshWindow (hwnd)
let il = 1
pause ()
while il < i
let il = il + 1
NextWord ()
endwhile
;LeftMouseButton ()
;PCCursor ()
EndFunction

Script Ejection ()
		;Ctrl+shift+j
WinCD (1)
if GetObjectName () != "Ejecter le CD" then
Refresh (1)
Delay (2)
PriorWord ()
saystring ("Refrapper Ctrl+maj+j")
else
LeftMouseButton ()
endif
PCCursor ()
EndScript

Script GoBack ()
		;Ctrl+shift+b
WinCD (2)
EndScript

Script GoFwd ()
		;ctrl+shift+f
WinCD (3)
EndScript

Script BoutonLire ()
		;Ctrl+shift+l
if QuelleFenetre () == sfn3 then
	PressButton (4)
else
TypeKey ("Shift+f4")
endif/*	WinCD (6)
endif
if GetObjectName () != "Lire une seule piste" then
Refresh (1)
Delay (2)
PriorChunk ()
saystring ("Refrapper Ctrl+maj+l")
else
LeftMouseButton ()
endif
PCCursor ()*/
EndScript

Script BoutonPose ()
		;ctrl+shift+p
if QuelleFenetre () == sfn3 then
	PressButton (5)
else
TypeKey ("shift+f6")
endif
/*	WinCD (8)
endif*/
EndScript

Script BoutonStop ()
		;ctrl+shift+o
if QuelleFenetre () == sfn3 then
	PressButton (6)
else
TypeKey ("Shift+f5")
;	WinCD (7)
endif
EndScript

Script BoutonPrecedent ()
		;ctrl+shift+k
if QuelleFenetre () == sfn3 then
	PressButton (2)
else
TypeKey ("Shift+f2")
;	WinCD (4)
;	{UpArrow}
endif
EndScript

Script BoutonSuivant ()
		;Ctrl+shift+m
if QuelleFenetre () == sfn3 then
	PressButton (3)
else
TypeKey ("Shift+f3")
;	WinCD (5)
;	{DownArrow}
endif
EndScript

String Function QuelleFenetre ()
let sCurrentView = GetWindowName (GetRealWindow (GetCurrentWindow ()))
if sCurrentView == "lecteur" ||
	sCurrentView == "CDex Player" then
	return sfn3
elif sCurrentView == "enregistrement" ||
	sCurrentView == "record" then
	return sfn2
elif sCurrentView == "CDex" then
	return sfn1
endif
EndFunction

Script NextSong ()
if IsPCCursor () && !MenusActive () && QuelleFenetre () == sfn1 && !UserBufferIsActive () == sfn1 then
	NextLine ()
	PerformScript BoutonStop()
	pause()
	PerformScript BoutonLire()
else
	PerformScript SayNextLine()
endif
EndScript

Script PriorSong ()
if IsPCCursor () && !MenusActive () && QuelleFenetre () == sfn1 && !UserBufferIsActive () == sfn1 then
	PriorLine ()
	PerformScript BoutonStop()
	pause()
	PerformScript BoutonLire()
else
	PerformScript SayPriorLine()
endif
EndScript

void Function TimeMainWnd ()
var handle hwnd, string thestring, string s1
let hwnd = FindDescendantWindow (GetAppMainWindow (GetCurrentWindow ()), 59393)
MoveToWindow (hwnd)
let thestring = GetWindowText (hwnd, false)
let s1 = thestring
let thestring = StringSegment (thestring, "(", 1)
let thestring = StringRight (thestring, 9)
PCCursor ()
saystring (thestring)
let s1 = StringSegment (s1, "(", 2)
let s1 = stringChopRight (s1, 12)
saystring (s1)
EndFunction

Script elapsedtime ()
		;Ctrl+shift+t
var handle hwnd, string s1, string s2, string sTime, string sMessage
if IsSameScript () then;pour le temps coul
	if QuelleFenetre () == sfn3 then
		let hwnd = GetNextWindow (GetNextWindow (GetNextWindow (GetNextWindow (GetCurrentWindow ())))) 
		let s2 = StringSegment (GetWindowText (hwnd, false), "/", 1)
		saystring (s2)
	elif QuelleFenetre () == sfn2 then
		return
	else
		TimeMainWnd ()
	endif
else;pour la dure du morceau
	if QuelleFenetre () == sfn1 then
		SaveCursor ()
		JAWSCursor ()
		RouteJAWSToPc ()
		NextChunk () NextChunk () NextChunk ()
		let sTime = ParseTime (GetWord ())
		let sMessage = FormatString ("%1", sTime)
		SayFormattedMessage (ot_no_disable, sMessage)
	elif QuelleFenetre () == sfn2 then
		let hwnd = FindDescendantWindow (GetTopLevelWindow (GetCurrentWindow ()), cid_timeEnreg)
		MoveToWindow (hwnd)
		SayWindow (hwnd, Read_Everything)
	elif QuelleFenetre () == sfn3 then
		let hwnd = GetNextWindow (GetNextWindow (GetNextWindow (GetNextWindow (GetCurrentWindow ())))) 
		let s1 = StringSegment (GetWindowText (hwnd, false), "/", 2)
		let s1 = StringSegment (s1, " ", 2)	
		let sTime = ParseTime (s1)
		let sMessage = FormatString ("%1", sTime)
		SayFormattedMessage (ot_no_disable, sMessage)
	else
		Return ;SayString ("pas dans la bonne fentre")
	endIf
EndIf
EndScript
;---------------------------------------